//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script$1 = {
  props: {
    size: {
      default: "128",
      type: String
    },
    multipleDragged: {
      default: false,
      type: Boolean
    },
    isLoading: {
      default: false,
      type: Boolean
    }
  },

  data() {
    return {
      isSelectedAddImageBtn: false,
      random: Math.random(),
      dragover: false,
      draggedFiles: [],
      isHovered: false
    };
  },

  mounted() {
    document.documentElement.style.setProperty("--size", `${this.size}px`);
  },

  methods: {
    onPaste(e) {
      let items = e.clipboardData && e.clipboardData.items;
      let file = null;

      if (items && items.length) {
        for (var i = 0; i < items.length; i++) {
          if (items[i].type.indexOf("image") !== -1) {
            file = items[i].getAsFile();
            break;
          }
        }
      }

      var reader = new FileReader();

      reader.onload = event => {
        if (this.isSelectedAddImageBtn) {
          this.$emit("paste", {
            src: event.target.result,
            file: file
          });
        }
      };

      reader.readAsDataURL(file);
    },

    getMask: function (e) {
      e.target.id === `addImageMask${this.random}` ? this.isSelectedAddImageBtn = true : this.isSelectedAddImageBtn = false;
    },

    onDrop(e) {
      this.draggedFiles = [];
      this.dragover = false;
      let files = e.dataTransfer.files;

      for (let file of files) {
        this.draggedFiles.push(file);
      }

      if (this.draggedFiles.length > 1 && !this.multipleDragged) {
        alert("只能一次拖拉一個檔案");
      } else if (this.draggedFiles.some(file => file.type.split("/")[0] !== "image")) {
        alert("請確認檔案格式,目前只支援jpeg/jpg/png");
      } else {
        this.draggedFiles.forEach(file => {
          var reader = new FileReader();

          reader.onload = event => {
            this.$emit("drop", {
              src: event.target.result,
              file: file
            });
          };

          reader.readAsDataURL(file);
        });
      }
    }

  },
  watch: {
    isHovered(newVal, oldVal) {
      if (newVal) {
        document.getElementsByClassName("image-input")[0].style.border = "1px solid rgb(165, 165, 165)";
      } else {
        document.getElementsByClassName("image-input")[0].style.border = "1px solid #ced4da";
      }
    },

    dragover(newVal, oldVal) {
      if (newVal) {
        document.getElementsByClassName("image-input")[0].style.border = "1px dashed orange";
      } else {
        document.getElementsByClassName("image-input")[0].style.border = "1px solid #ced4da";
      }
    }

  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
const __vue_script__$1 = script$1;
/* template */

var __vue_render__$1 = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    staticStyle: {
      "position": "relative",
      "margin": "0 10px 10px 0"
    }
  }, [_c('div', {
    staticClass: "addImageBtn",
    attrs: {
      "id": "addImageBtn" + _vm.random,
      "tabindex": "0"
    }
  }, [!_vm.isLoading ? _c('center', {
    staticStyle: {
      "color": "gray",
      "position": "relative",
      "top": "50%",
      "transform": "translate(0, -50%)"
    }
  }, [_vm._v("\n      點擊"), _c('br'), _vm._v("crtl+v 貼上"), _c('br'), _c('br'), _vm._v("OR"), _c('br'), _c('br'), _vm._v("拖拉圖片"), _vm.multipleDragged ? _c('span', [_vm._v("(多張)")]) : _c('span', [_vm._v("(單張)")])]) : _vm._e()], 1), _vm._v(" "), _c('textarea', {
    staticClass: "image-input",
    staticStyle: {
      "position": "absolute"
    },
    attrs: {
      "id": "addImageMask" + _vm.random
    },
    on: {
      "mouseenter": function ($event) {
        _vm.isHovered = true;
      },
      "mouseleave": function ($event) {
        _vm.isHovered = false;
      },
      "drop": function ($event) {
        $event.preventDefault();
        return _vm.onDrop($event);
      },
      "dragover": function ($event) {
        $event.preventDefault();
        _vm.dragover = true;
      },
      "dragenter": function ($event) {
        $event.preventDefault();
        _vm.dragover = true;
      },
      "dragleave": function ($event) {
        $event.preventDefault();
        _vm.dragover = false;
      },
      "click": _vm.getMask,
      "paste": _vm.onPaste
    }
  }), _vm._v(" "), _c('div', {
    staticStyle: {
      "top": "50%",
      "left": "50%",
      "transform": "translate(-50%, -50%)",
      "position": "absolute"
    }
  }, [_vm.isLoading ? _c('b-spinner', {
    attrs: {
      "variant": "secondary"
    }
  }) : _vm._e()], 1)]);
};

var __vue_staticRenderFns__$1 = [];
/* style */

const __vue_inject_styles__$1 = function (inject) {
  if (!inject) return;
  inject("data-v-283ea357_0", {
    source: "[data-v-283ea357]:root{--size:128px}.addImageBtn[data-v-283ea357]{width:var(--size);height:var(--size);background:#fff;border-radius:3px;font-size:12px}.image-input[data-v-283ea357]{width:var(--size);height:var(--size);background:0 0;bottom:0;caret-color:transparent;color:transparent;cursor:default;resize:none;border:1px solid #ced4da;border-radius:.2rem;overflow:hidden;padding:0}textarea[data-v-283ea357]{border:none}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__$1 = "data-v-283ea357";
/* module identifier */

const __vue_module_identifier__$1 = undefined;
/* functional template */

const __vue_is_functional_template__$1 = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, createInjector, undefined, undefined);

var __vue_component__$3 = __vue_component__$2;

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
var script = {
  name: "Container",
  props: {
    data: {
      type: Object,
      default: null
    },
    editMode: {
      default: false,
      type: Boolean
    },
    size: {
      default: "128",
      type: String
    }
  },

  data() {
    return {
      loaded: false,
      isHovered: false
    };
  },

  mounted() {
    this.size > 115 ? console.warn("圖片容器框目前最大長寬尺寸為115px") : document.documentElement.style.setProperty("--size", `${this.size}px`);
  },

  methods: {
    async openImg(src) {
      if (!src.includes("http")) src = URL.createObjectURL(await (await fetch(src)).blob());
      window.open(src);
    },

    imgResize(src) {
      const vue = this;
      const img = new Image();

      img.onload = function () {
        if (this.width < this.height) {
          vue.$refs.imgs.classList.remove("widthMoreHeight");
          vue.$refs.imgs.classList.add("heightMoreWidth");
        } else {
          vue.$refs.imgs.classList.remove("heightMoreWidth");
          vue.$refs.imgs.classList.add("widthMoreHeight");
        }

        vue.loaded = true;
      };

      img.src = src;
    },

    removeImages(id) {
      this.$emit("delete", id);
    }

  },
  watch: {
    data: {
      immediate: true,

      handler(newVal, oldVal) {
        this.loaded = false;
        this.imgResize(newVal.src);
      }

    }
  },
  computed: {
    getSrc() {
      return this.loaded ? this.data.src : null;
    }

  }
};

/* script */
const __vue_script__ = script;
/* template */

var __vue_render__ = function () {
  var _vm = this;

  var _h = _vm.$createElement;

  var _c = _vm._self._c || _h;

  return _c('div', {
    on: {
      "mouseenter": function ($event) {
        _vm.isHovered = true;
      },
      "mouseleave": function ($event) {
        _vm.isHovered = false;
      }
    }
  }, [_vm.data !== null ? _c('div', {
    staticClass: "wrapper",
    staticStyle: {
      "position": "relative"
    }
  }, [_c('i', {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.editMode && _vm.isHovered,
      expression: "editMode && isHovered"
    }],
    staticClass: "delete gg-remove",
    staticStyle: {
      "position": "absolute"
    },
    attrs: {
      "title": "移除"
    },
    on: {
      "click": function ($event) {
        return _vm.removeImages(_vm.data._id);
      }
    }
  }), _vm._v(" "), _c('img', {
    ref: "imgs",
    staticStyle: {
      "position": "absolute",
      "cursor": "pointer"
    },
    attrs: {
      "title": "點擊放大",
      "src": _vm.getSrc
    },
    on: {
      "click": function ($event) {
        return _vm.openImg(_vm.data.src);
      }
    }
  })]) : _vm._e()]);
};

var __vue_staticRenderFns__ = [];
/* style */

const __vue_inject_styles__ = function (inject) {
  if (!inject) return;
  inject("data-v-9eafb266_0", {
    source: "@import url(https://fonts.googleapis.com/css?family=Roboto+Condensed);[data-v-9eafb266]:root{--size:115px}.wrapper[data-v-9eafb266]{font-family:\"Gill Sans\",sans-serif!important;z-index:10000;width:var(--size);height:var(--size);border:1px #e4e4e4 solid;border-radius:3px;background:#fff;margin:0 10px 10px 0}.wrapper .delete[data-v-9eafb266]{color:#000;font-size:20px;top:3px;right:3px;z-index:2;font-style:normal;cursor:pointer}.wrapper .delete[data-v-9eafb266]:hover{color:#e24646}.wrapper .delete[data-v-9eafb266]:active{color:#b80000}.widthMoreHeight[data-v-9eafb266]{width:var(--size)!important;height:auto;top:50%;transform:translate(0,-50%)}.heightMoreWidth[data-v-9eafb266]{width:auto;height:var(--size)!important;left:50%;transform:translate(-50%,0);border-radius:3px}.show[data-v-9eafb266]{opacity:10}.disappear[data-v-9eafb266]{opacity:0}.click-danger[data-v-9eafb266]{color:var(--dark);cursor:pointer}.gg-remove[data-v-9eafb266]{box-sizing:border-box;position:relative;display:block;transform:scale(var(--ggs,1));width:15px;height:15px;border:1.5px solid;border-radius:15px}.gg-remove[data-v-9eafb266]::before{content:\"\";display:block;box-sizing:border-box;position:absolute;width:8px;height:1.5px;background:currentColor;border-radius:3px;top:5.4px;left:2px}",
    map: undefined,
    media: undefined
  });
};
/* scoped */


const __vue_scope_id__ = "data-v-9eafb266";
/* module identifier */

const __vue_module_identifier__ = undefined;
/* functional template */

const __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

const __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

var __vue_component__$1 = __vue_component__;

/* eslint-disable import/prefer-default-export */

var components = /*#__PURE__*/Object.freeze({
  __proto__: null,
  addImageButton: __vue_component__$3,
  imageContainer: __vue_component__$1
});

// Import vue components

const install = function installImagesContainer(Vue) {
  Object.entries(components).forEach(_ref => {
    let [componentName, component] = _ref;
    Vue.component(componentName, component);
  });
}; // Create module definition for Vue.use()

export { __vue_component__$3 as addImageButton, install as default, __vue_component__$1 as imageContainer };
